package com.hfkj.dao;

import com.hfkj.entity.BsOrderSettle;
import com.hfkj.entity.BsOrderSettleExample.Criteria;
import com.hfkj.entity.BsOrderSettleExample.Criterion;
import com.hfkj.entity.BsOrderSettleExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderSettleSqlProvider {

    public String countByExample(BsOrderSettleExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_settle");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderSettleExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_settle");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderSettle record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_settle");
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleMerNo() != null) {
            sql.VALUES("settle_mer_no", "#{settleMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleMerKey() != null) {
            sql.VALUES("settle_mer_key", "#{settleMerKey,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleAmount() != null) {
            sql.VALUES("settle_amount", "#{settleAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getLedgerFlag() != null) {
            sql.VALUES("ledger_flag", "#{ledgerFlag,jdbcType=BIT}");
        }
        
        if (record.getLedgerOrderNo() != null) {
            sql.VALUES("ledger_order_no", "#{ledgerOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getLedgerAmount() != null) {
            sql.VALUES("ledger_amount", "#{ledgerAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getLedgerStatus() != null) {
            sql.VALUES("ledger_status", "#{ledgerStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRevokeOrderNo() != null) {
            sql.VALUES("revoke_order_no", "#{revokeOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderSettleExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_no");
        sql.SELECT("order_no");
        sql.SELECT("settle_mer_no");
        sql.SELECT("settle_mer_key");
        sql.SELECT("settle_amount");
        sql.SELECT("ledger_flag");
        sql.SELECT("ledger_order_no");
        sql.SELECT("ledger_amount");
        sql.SELECT("ledger_status");
        sql.SELECT("revoke_order_no");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_settle");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderSettle record = (BsOrderSettle) parameter.get("record");
        BsOrderSettleExample example = (BsOrderSettleExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_settle");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleMerNo() != null) {
            sql.SET("settle_mer_no = #{record.settleMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleMerKey() != null) {
            sql.SET("settle_mer_key = #{record.settleMerKey,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleAmount() != null) {
            sql.SET("settle_amount = #{record.settleAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getLedgerFlag() != null) {
            sql.SET("ledger_flag = #{record.ledgerFlag,jdbcType=BIT}");
        }
        
        if (record.getLedgerOrderNo() != null) {
            sql.SET("ledger_order_no = #{record.ledgerOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getLedgerAmount() != null) {
            sql.SET("ledger_amount = #{record.ledgerAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getLedgerStatus() != null) {
            sql.SET("ledger_status = #{record.ledgerStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRevokeOrderNo() != null) {
            sql.SET("revoke_order_no = #{record.revokeOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_settle");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("settle_mer_no = #{record.settleMerNo,jdbcType=VARCHAR}");
        sql.SET("settle_mer_key = #{record.settleMerKey,jdbcType=VARCHAR}");
        sql.SET("settle_amount = #{record.settleAmount,jdbcType=DECIMAL}");
        sql.SET("ledger_flag = #{record.ledgerFlag,jdbcType=BIT}");
        sql.SET("ledger_order_no = #{record.ledgerOrderNo,jdbcType=VARCHAR}");
        sql.SET("ledger_amount = #{record.ledgerAmount,jdbcType=DECIMAL}");
        sql.SET("ledger_status = #{record.ledgerStatus,jdbcType=INTEGER}");
        sql.SET("revoke_order_no = #{record.revokeOrderNo,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderSettleExample example = (BsOrderSettleExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderSettle record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_settle");
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleMerNo() != null) {
            sql.SET("settle_mer_no = #{settleMerNo,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleMerKey() != null) {
            sql.SET("settle_mer_key = #{settleMerKey,jdbcType=VARCHAR}");
        }
        
        if (record.getSettleAmount() != null) {
            sql.SET("settle_amount = #{settleAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getLedgerFlag() != null) {
            sql.SET("ledger_flag = #{ledgerFlag,jdbcType=BIT}");
        }
        
        if (record.getLedgerOrderNo() != null) {
            sql.SET("ledger_order_no = #{ledgerOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getLedgerAmount() != null) {
            sql.SET("ledger_amount = #{ledgerAmount,jdbcType=DECIMAL}");
        }
        
        if (record.getLedgerStatus() != null) {
            sql.SET("ledger_status = #{ledgerStatus,jdbcType=INTEGER}");
        }
        
        if (record.getRevokeOrderNo() != null) {
            sql.SET("revoke_order_no = #{revokeOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderSettleExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}